Subject: Re: bug#54993: 28.1; Editing etc/NEWS on master with Emacs 28 signals an error

From: Jim Porter <[email-masked]>
Date: Sun, 17 Apr 2022 13:17:20 -0700

On 4/17/2022 10:44 AM, Eli Zaretskii wrote:
>    emacs -Q
>    C-x C-f etc/NEWS RET
> 
> Observe an error message:
> 
>    File local-variables error: (void-function emacs-news-mode)
> 
> and NEWS is visited in Fundamental mode, which makes it annoyingly
> inconvenient to edit the news entries.
> 
> I think a new mode that is only available in the development version
> should not be forced on all the developers, because not all of them
> use the latest-and-the-greatest code all the time while working on
> Emacs.

This doesn't seem to work in Emacs 28.1 anymore, but at least on 27.2, I 
used the following strategy:

   # -*- mode: FOO; mode: BAR -*-

This way, it would try to load FOO-mode and then BAR-mode in order, and 
so I could set up the mode for files to ensure that users with BAR-mode 
available can use that, but it falls back to FOO-mode otherwise. 
Unfortunately, in Emacs 28.1, this now fails with:

   File local-variables error: (error Lisp nesting exceeds 
‘max-lisp-eval-depth’)

Maybe the strategy I was using is just an abuse of file-local variables, 
but I think it's a convenient way to do things like this, and would 
nicely solve this issue too. (If you prefer, I could file a separate bug 
for the regression with file-local variable handling.)